<?php

namespace FM\Service;

use FM\Factory\ParamGeralFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class ParamGeralService {

    protected $ParamGeralFactory;
    protected $Environment;
    protected $newCode;
    protected $connection;

    public function __construct (ParamGeralFactory $ParamGeralFactory, Environment $Environment, NewCode $newCode, EntityManager $entityManager) {
        $this->ParamGeralFactory = $ParamGeralFactory;
        $this->Environment = $Environment;
        $this->newCode = $newCode;
        $this->connection = $entityManager->getConnection();
    }
    
    public function postMascara($params){
        $this->connection->beginTransaction();
        try {
            $NRORG =  $this->Environment->getNrOrg();
            $dados = array(
                "IDOBRIGACDLOCAT" => $params['IDOBRIGACDLOCAT'],
                "IDUTILIZAMASCCDLOCAT" => $params['IDUTILIZAMASCCDLOCAT'],
                "DSMASCCDLOCAT" => $params['DSMASCCDLOCAT'],
                "IDALTERAMASCCDLOCAT" => $params['IDALTERAMASCCDLOCAT'],
                "CDOPERULTATU" => $this->Environment->getCdOperador(),
                "NRORGINCLUSAO" => $NRORG,
                "NRORGULTATU" => $NRORG
            );
            $respostaDB = $this->ParamGeralFactory->getCountMascara();
            if(!($respostaDB[0]['QTA'])){
                $dados["NRPARAMGERAL"] = $this->newCode->getCodeByTableName("FCM_PARAMGERAL", $NRORG, 1, 10, true);
                $dados["CDOPERINCLUSAO"] = $this->Environment->getCdOperador();
                $dados["NRORG"] = $NRORG;
                $this->ParamGeralFactory->postMascara($dados);
            } else {
                $this->ParamGeralFactory->updateMascara($dados);
            }
            $this->connection->commit();
            $response = ["OK"];
        }
        catch(\Exception $e) {
             $this->connection->rollback();
             $response = [utf8_decode($e->getErrorCode())];
        }
        
        return $response;
    }
    
    public function getMascara(){
         return $this->ParamGeralFactory->getMascara();
    }
}

?>