/* Sistemas Integrados TECNISA

Nome: 9801_CDPTRGO_LOG_CDP_PROCFABRICA.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   16/02/2009 - Henrique Guidi Lobato
*/

/* Tabela PROCFABRICA.*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir das alteraes na tabela
              PROCFABRICA, para verifio de erros */
CREATE OR REPLACE TRIGGER LOG_CDP_PROCFABRICA
AFTER DELETE OR INSERT OR UPDATE
ON PROCFABRICA FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(300);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_NRINCREST    VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_CDFILLOGOPER VARCHAR2(4);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_NRINCREST  := '';
   V_IDTIPOOPER := '';
   V_CDFILLOGOPER := '';
   
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF INSERTING THEN 

         IF :NEW.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial= ' || NVL(:NEW.CDFILIAL,'') || ' ' ;
         END IF;

         IF :NEW.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProd= ' || NVL(:NEW.CDPRODUTO,'') || ' ' ;
         END IF;

         IF :NEW.CDPROCFABRIC IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProcFabric= ' || NVL(:NEW.CDPROCFABRIC,'') || ' ' ;
         END IF;
         
         IF :NEW.DTVALPROFABR IS NOT NULL THEN
            V_DESC := V_DESC || 'DataValProFabr= '|| TO_CHAR(:NEW.DTVALPROFABR, 'DD/MM/YYYY') || ' ' ;
         END IF;

         IF :NEW.CDOPERADOR IS NOT NULL THEN
         V_DESC := V_DESC || 'CdOperador= ' || NVL(:NEW.CDOPERADOR,'') || ' ' ;
         END IF;  

         IF :NEW.IDPROFABPADR IS NOT NULL THEN 
            V_DESC := V_DESC || 'Padrao= ' || :NEW.IDPROFABPADR || ' ' ;
         END IF;

         IF :NEW.QTPADPROCFAB IS NOT NULL THEN
            V_DESC := V_DESC || 'QtdePadProd= ' || TO_CHAR(:NEW.QTPADPROCFAB) || ' ' ;
	 END IF;

         IF :NEW.QTLOTEFABDIA IS NOT NULL THEN
            V_DESC := V_DESC || 'Lote/Dia= ' || TO_CHAR(:NEW.QTLOTEFABDIA) || ' ' ;
	 END IF;

         IF :NEW.IDTPPROPOPF IS NOT NULL THEN
            V_DESC := V_DESC || 'Proporcao= ' || :NEW.IDTPPROPOPF || ' ' ;
	 END IF;

         IF :NEW.IDTPARREDPF IS NOT NULL THEN
            V_DESC := V_DESC || 'Arredondar= ' || :NEW.IDTPARREDPF || ' ' ;
	 END IF;

      V_ITPESQ := :NEW.CDFILIAL     || :NEW.CDPRODUTO   || :NEW.CDPROCFABRIC;
                  
      V_IDTIPOOPER := '1';  
      V_CDFILLOGOPER := :NEW.CDFILIAL; 

   ELSE
      IF UPDATING THEN

         IF (:NEW.CDFILIAL <> :OLD.CDFILIAL) THEN
            V_DESC := V_DESC || 'Filial= ' || NVL(:NEW.CDFILIAL,'') || ' ' ;
         END IF;

         IF (:NEW.CDPRODUTO <> :OLD.CDPRODUTO) THEN
            V_DESC := V_DESC || 'CdProd= ' || NVL(:NEW.CDPRODUTO,'') || ' ' ;
         END IF;

         IF (:NEW.CDPROCFABRIC <> :OLD.CDPROCFABRIC) THEN
            V_DESC := V_DESC || 'CdProcFabric= ' || NVL(:NEW.CDPROCFABRIC,'') || ' ' ;
         END IF;
         
         IF (:NEW.DTVALPROFABR <> :OLD.DTVALPROFABR) THEN
            V_DESC := V_DESC || 'DataValProFabr= '|| TO_CHAR(:NEW.DTVALPROFABR, 'DD/MM/YYYY') || ' ' ;
         END IF;

         IF (:NEW.CDOPERADOR <> :OLD.CDOPERADOR) THEN
         V_DESC := V_DESC || 'CdOperador= ' || NVL(:NEW.CDOPERADOR,'') || ' ' ;
         END IF;  

         IF (:NEW.IDPROFABPADR <> :OLD.IDPROFABPADR) THEN 
            V_DESC := V_DESC || 'Padrao= ' || :NEW.IDPROFABPADR || ' ' ;
         END IF;

         IF (:NEW.QTPADPROCFAB <> :OLD.QTPADPROCFAB) THEN
            V_DESC := V_DESC || 'QtdePadProd= ' || TO_CHAR(:NEW.QTPADPROCFAB) || ' ' ;
	 END IF;

         IF (:NEW.QTLOTEFABDIA <> :OLD.QTLOTEFABDIA) THEN
            V_DESC := V_DESC || 'Lote/Dia= ' || TO_CHAR(:NEW.QTLOTEFABDIA) || ' ' ;
	 END IF;

         IF (:NEW.IDTPPROPOPF <> :OLD.IDTPPROPOPF) THEN
            V_DESC := V_DESC || 'Proporcao= ' || :NEW.IDTPPROPOPF || ' ' ;
	 END IF;

         IF (:NEW.IDTPARREDPF <> :OLD.IDTPARREDPF) THEN
            V_DESC := V_DESC || 'Arredondar= ' || :NEW.IDTPARREDPF || ' ' ;
	 END IF;
         
         V_ITPESQ := :NEW.CDFILIAL     || :NEW.CDPRODUTO   || :NEW.CDPROCFABRIC;

             V_IDTIPOOPER := '2';    
             V_CDFILLOGOPER := :NEW.CDFILIAL; 
          
      END IF; 
      IF DELETING  THEN

         IF :OLD.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial= ' || NVL(:OLD.CDFILIAL,'') || ' ' ;
         END IF;

         IF :OLD.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProd= ' || NVL(:OLD.CDPRODUTO,'') || ' ' ;
         END IF;

         IF :OLD.CDPROCFABRIC IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProcFabric= ' || NVL(:OLD.CDPROCFABRIC,'') || ' ' ;
         END IF;
         
         IF :OLD.DTVALPROFABR IS NOT NULL THEN
            V_DESC := V_DESC || 'DataValProFabr= '|| TO_CHAR(:OLD.DTVALPROFABR, 'DD/MM/YYYY') || ' ' ;
         END IF;

         IF :OLD.CDOPERADOR IS NOT NULL THEN
         V_DESC := V_DESC || 'CdOperador= ' || NVL(:OLD.CDOPERADOR,'') || ' ' ;
         END IF;  

         IF :OLD.IDPROFABPADR IS NOT NULL THEN 
            V_DESC := V_DESC || 'Padrao= ' || :OLD.IDPROFABPADR || ' ' ;
         END IF;

         IF :OLD.QTPADPROCFAB IS NOT NULL THEN
            V_DESC := V_DESC || 'QtdePadProd= ' || TO_CHAR(:OLD.QTPADPROCFAB) || ' ' ;
	 END IF;

         IF :OLD.QTLOTEFABDIA IS NOT NULL THEN
            V_DESC := V_DESC || 'Lote/Dia= ' || TO_CHAR(:OLD.QTLOTEFABDIA) || ' ' ;
	 END IF;

         IF :OLD.IDTPPROPOPF IS NOT NULL THEN
            V_DESC := V_DESC || 'Proporcao= ' || :OLD.IDTPPROPOPF || ' ' ;
	 END IF;

         IF :OLD.IDTPARREDPF IS NOT NULL THEN
            V_DESC := V_DESC || 'Arredondar= ' || :OLD.IDTPARREDPF || ' ' ;
	 END IF;
         
         V_ITPESQ := :OLD.CDFILIAL     || :OLD.CDPRODUTO   || :OLD.CDPROCFABRIC;
   
         V_IDTIPOOPER := '3';
         V_CDFILLOGOPER := :OLD.CDFILIAL;

      END IF;
   END IF;   
   IF NOT (V_DESC IS NULL) THEN   
      INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                             IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                             DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                             DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
                   VALUES  ('PROCFABRICA', SYSDATE ,    NVL(V_NMOPERADOR,' '),
                             V_IDTIPOOPER,   V_DESC, V_ITPESQ,
                             V_DSSERVERRDM, V_DSREMOTEADDR,  V_DSREMOTEHOST,
                             V_DSSERVMETHOD,   V_DSREMOTEOPER, V_CDFILLOGOPER);    
   END IF;
END;

/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_CDP_PROCFABRICA','5.07.001'); END;
/   
